include (jslib_dir);
include (jslib_fileutils);
include (jslib_file);
include ("chrome://mozimage/content/mozimage_prefs.js");

/*
**
** Private function
**
*/

function autoSize()
{
  var image = document.getElementById("main-image");
  var newImage = new Image();
  newImage.setAttribute("id", "thepreviewimage");
  newImage.src = image.src;
  var box = document.getElementById("image-box");
  var boxWidth = box.boxObject.width;
  var boxHeight = box.boxObject.height;
  var filename = image.src;
  var xratio = newImage.width / boxWidth;
  var yratio = newImage.height / boxHeight;
  var ratio = (xratio > yratio) ? xratio : yratio;
  
  image.src = "";
  image.width = newImage.width / ratio;
  image.height = newImage.height / ratio;
  image.src = filename;
}

function updateDescription()
{
  var image = document.getElementById("main-image");
  var info = document.getElementById("info-label");
  var newImage = new Image();
  newImage.setAttribute("id", "thepreviewimage");
  newImage.src = image.src;
  info.value = "Width: " + newImage.width + " - Height: " + newImage.height;
}

function fillListBox(adir)
{
  var dirlistbox = document.getElementById("directory-listbox");
  var filelistbox = document.getElementById("file-listbox");
  var d = new Dir(adir);
  var dirList = d.readDir();
  var fullpath = document.getElementById("fullpath-text");

  var dirs = new Array();
  var files = new Array();
  
  emptyList();
  fullpath.value = adir;


  for (var i = 0 ; i < dirList.length ; i++) 
    dirList[i].isDir() ?  dirs.push(dirList[i]) : files.push(dirList[i]);

  dirs.sort();
  files.sort();

  dirList = new Array();

  for (var i = 0 ; i < dirs.length ; i++)
    dirlistbox.appendItem(dirs[i].leaf, '');

  for (var i = 0 ; i < files.length ; i++)
    if (supportedType(files[i]))
      filelistbox.appendItem(files[i].leaf, '');
    
  prefs.setHomeDir(adir);
   
}

function supportedType(file)
{
  var result = false;
  var extList = prefs.getExtList();
  for (var i = 0 ; i < extList.length ; i++)
  {
    if (extList[i].toUpperCase() == file.ext.toUpperCase())
      result = true;
  }    
  return(result);
}

function emptyList()
{
  var dirlistbox = document.getElementById("directory-listbox");
  var filelistbox = document.getElementById("file-listbox");
  var item;
  
  var i = dirlistbox.getRowCount();
  while (i > 0)
  {
    i--;
    item = dirlistbox.getItemAtIndex(i);
    dirlistbox.removeChild(item);
  }
  i = filelistbox.getRowCount();
  while (i > 0)
  {
    i--;
    item = filelistbox.getItemAtIndex(i);
    filelistbox.removeChild(item);
  }

}

/*
**
** Event handler
**
*/

function window_load(event)
{
  var autoSizeMenu = document.getElementById("autosize-menu");
  autoSizeMenu.setAttribute("checked", prefs.getAutoSize());

  fillListBox(prefs.getHomeDir());
}

function window_close(event)
{
  prefs.save();
}

function about_click()
{
  window.openDialog('chrome://mozimage/content/mozimage_about.xul', 'about', 'chrome,centerscreen,dialog,modal');
}

function exit_click()
{
  window.close();
}

function image_resize()
{
  if (prefs.getAutoSize())
    autoSize();
}

function autosize_click()
{
  var autoSizeMenu = document.getElementById("autosize-menu");
  prefs.setAutoSize(autoSizeMenu.getAttribute("checked"));
}

function prior_click()
{
  var fileListBox = document.getElementById("file-listbox");
  var selectedIndex = fileListBox.selectedIndex;
  if (selectedIndex >= 1)
    fileListBox.selectedIndex = selectedIndex - 1;
  else
    fileListBox.selectedIndex =  fileListBox.getRowCount() - 1;
  fileListBox.ensureIndexIsVisible ( fileListBox.selectedIndex );
}

function next_click()
{
  var fileListBox = document.getElementById("file-listbox");
  var selectedIndex = fileListBox.selectedIndex;
  if (selectedIndex >= -1 && selectedIndex < fileListBox.getRowCount() - 1)
    fileListBox.selectedIndex = selectedIndex + 1;
  else
    fileListBox.selectedIndex = 0;
  fileListBox.ensureIndexIsVisible ( fileListBox.selectedIndex );
}

function up_click()
{
  var fullpath = document.getElementById("fullpath-text");
  var fileUtil = new FileUtils();
  if (fullpath.value)
  {
    var aPath = fullpath.value;
    var file = new File(aPath);
    var aParent = file.parent.path;
    fillListBox(aParent);
  }
}

function go_click(event)
{
  var fullpath = document.getElementById("fullpath-text");
  fillListBox(fullpath.value);
}

function directory_select(event)
{
  var selectedItem = event.target.selectedItem;
  var basePath = document.getElementById("fullpath-text");
  var path = selectedItem.getAttribute("label");
  var fileUtil = new FileUtils();

  fillListBox(fileUtil.append(basePath.value, path));
}

function file_select(event)
{
  var selectedItem = event.target.selectedItem;
  var mainImage = document.getElementById("main-image");
  var basePath = document.getElementById("fullpath-text");
  var fileUtil = new FileUtils();
  
  mainImage.removeAttribute('width');
  mainImage.removeAttribute('height');
  mainImage.src = 'file:///' + fileUtil.append(basePath.value, selectedItem.label);

  if (prefs.getAutoSize())
    setTimeout(autoSize, 0);

  // update discription out of the main thread
  setTimeout(updateDescription, 100);
}

